﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace KonkeDemo
{
    public class AutoTestService
    {
        public delegate void SendMessageEventHandler(Helper.CustomMessage customMessage, string recv);

        public event SendMessageEventHandler SendMessage;

        public const int stateJoinNetWork = 0;  //设备入网
        public const int stateGetInfo = 1;  //获取设备信息
        public const int stateGetRssi = 2;  //获取rssi
        public const int stateAction = 3;  //操作设备
        public const int stateLED = 4;
        public const int stateWriteAndRead = 5;//序列号写入
        public const int stateRetireNetS = 6;//退网(成功)
        public const int stateSuccess = 7;//测试成功
        public const int stateFailed = 8;//测试失败
        public const int statePower = 9; //功率校准
        public const int stateOpen = 10; //下发开
        public const int stateToFailing = 11;//测试失败
        public const int stateClose = 12; //下发开
        public int OutTimeFlag = -1;//超时标志位
        protected int timerTick;//协调器状态

        public int nowStep = stateJoinNetWork;//协调器状态
        bool FlagW = true;
        public virtual void Run(object obj)
        {
            try
            {
                while (FlagW)
                {
                    if (Helper.Stop)
                    {
                        FlagW = false;
                        break;
                    }
                    System.Threading.Thread.Sleep(100);
                    //模组测试流程
                    RunMachineTest();
                }
            }
            catch (Exception exc) { }
        }

        public void RunMachineTest()//整机产测执行函数,返回进度
        {
            timerTick++;
            //执行整机产测的每个步骤
            if (timerTick % 10 == 0) //约2s执行一次
            {
                switch (nowStep)
                {
                    case stateJoinNetWork:
                        {
                            if (OutTimeFlag == -1)
                                OutTimeFlag = timerTick;
                            if ((timerTick - OutTimeFlag) > 50)  //10s
                            {
                                nowStep = stateFailed;
                                OutTimeFlag = -1;
                                Console.WriteLine(string.Format("入网超时"));
                                SendMessage(Helper.CustomMessage.ViewLog, "入网超时");
                                SendMessage(Helper.CustomMessage.Progress, "25");
                                SendMessage(Helper.CustomMessage.Alarm, "入网超时");

                            }
                            Random random = new Random();
                            int iConclusion = random.Next(0, 2);
                            if (iConclusion == 0) 
                            {
                                nowStep = stateFailed;
                                OutTimeFlag = -1;
                                Console.WriteLine(string.Format("入网失败"));
                                SendMessage(Helper.CustomMessage.ViewLog, "入网失败");
                                SendMessage(Helper.CustomMessage.Progress, "25");
                                SendMessage(Helper.CustomMessage.Alarm, "入网失败");

                            }
                            else if (iConclusion == 1)
                            {
                                nowStep = stateGetInfo;
                                OutTimeFlag = -1;
                                Console.WriteLine(string.Format("入网成功"));
                                SendMessage(Helper.CustomMessage.ViewLog, "入网成功");
                                SendMessage(Helper.CustomMessage.Progress, "25");

                            }
                        }
                        break;
                    case stateGetInfo:
                        {
                            if (OutTimeFlag == -1)
                                OutTimeFlag = timerTick;
                            if ((timerTick - OutTimeFlag) > 50)  //10s
                            {
                                nowStep = stateFailed;
                                OutTimeFlag = -1;
                                Console.WriteLine(string.Format("读取版本号超时"));
                                SendMessage(Helper.CustomMessage.ViewLog, "读取版本号超时");
                                SendMessage(Helper.CustomMessage.Progress, "50");
                                SendMessage(Helper.CustomMessage.Alarm, "读取版本号超时");

                            }
                            Random random = new Random();
                            int iConclusion = random.Next(0, 2);
                            if (iConclusion == 0)
                            {
                                nowStep = stateFailed;
                                OutTimeFlag = -1;
                                Console.WriteLine(string.Format("读取版本号失败"));
                                SendMessage(Helper.CustomMessage.ViewLog, "读取版本号失败");
                                SendMessage(Helper.CustomMessage.Progress, "50");
                                SendMessage(Helper.CustomMessage.Alarm, "读取版本号失败");

                            }
                            else if (iConclusion == 1) 
                            {
                                nowStep = stateGetRssi;
                                OutTimeFlag = -1;
                                Console.WriteLine(string.Format("读取版本号成功"));
                                SendMessage(Helper.CustomMessage.ViewLog, "读取版本号成功");
                                SendMessage(Helper.CustomMessage.Progress, "50");

                            }
                        }
                        break;
                    case stateGetRssi:
                        {
                            if (OutTimeFlag == -1)
                                OutTimeFlag = timerTick;
                            if ((timerTick - OutTimeFlag) > 50)  //10s
                            {
                                nowStep = stateFailed;
                                OutTimeFlag = -1;
                                Console.WriteLine(string.Format("读取信号强度超时"));
                                SendMessage(Helper.CustomMessage.ViewLog, "读取信号强度超时");
                                SendMessage(Helper.CustomMessage.Progress, "75");
                                SendMessage(Helper.CustomMessage.Alarm, "读取信号强度超时");

                            }
                            Random random = new Random();
                            int iConclusion = random.Next(0, 2);
                            if (iConclusion == 0)
                            {
                                nowStep = stateFailed;
                                OutTimeFlag = -1;
                                Console.WriteLine(string.Format("读取信号强度失败"));
                                SendMessage(Helper.CustomMessage.ViewLog, "读取信号强度失败");
                                SendMessage(Helper.CustomMessage.Progress, "75");
                                SendMessage(Helper.CustomMessage.Alarm, "读取信号强度失败");

                            }
                            else if (iConclusion == 1)
                            {
                                nowStep = stateWriteAndRead;
                                OutTimeFlag = -1;
                                Console.WriteLine(string.Format("读取信号强度成功"));
                                SendMessage(Helper.CustomMessage.ViewLog, "读取信号强度成功");
                                SendMessage(Helper.CustomMessage.Progress, "75");

                            }
                        }
                        break;
                    case stateWriteAndRead:
                        {
                            if (OutTimeFlag == -1)
                                OutTimeFlag = timerTick;
                            if ((timerTick - OutTimeFlag) > 50)  //10s
                            {
                                nowStep = stateFailed;
                                OutTimeFlag = -1;
                                Console.WriteLine(string.Format("读取InstallCode超时"));
                                SendMessage(Helper.CustomMessage.ViewLog, "读取InstallCode超时");
                                SendMessage(Helper.CustomMessage.Progress, "100");
                                SendMessage(Helper.CustomMessage.Alarm, "读取InstallCode超时");

                            }
                            Random random = new Random();
                            int iConclusion = random.Next(0, 2);
                            if (iConclusion == 0)
                            {
                                nowStep = stateFailed;
                                OutTimeFlag = -1;
                                Console.WriteLine(string.Format("读取InstallCode失败"));
                                SendMessage(Helper.CustomMessage.ViewLog, "读取InstallCode失败");
                                SendMessage(Helper.CustomMessage.Progress, "100");
                                SendMessage(Helper.CustomMessage.Alarm, "读取InstallCode失败");

                            }
                            else if (iConclusion == 1)
                            {
                                nowStep = stateSuccess;
                                OutTimeFlag = -1;
                                Console.WriteLine(string.Format("读取InstallCode成功"));
                                SendMessage(Helper.CustomMessage.ViewLog, "读取InstallCode成功");
                                SendMessage(Helper.CustomMessage.Progress, "100");

                            }
                        }
                        break;
                    case stateSuccess:
                        {
                            FlagW = false;
                            SendMessage(Helper.CustomMessage.Result, "1");
                            SendMessage(Helper.CustomMessage.Progress, "100");
                            SendMessage(Helper.CustomMessage.ViewLog, "成功");

                        }
                        break;
                    case stateFailed:
                        {
                            FlagW = false;
                            SendMessage(Helper.CustomMessage.Result, "0");

                        }
                        break;
                    default:
                        break;
                }
            }
        }
    }
}
