﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace KonkeDemo
{
    public partial class Configure : Form
    {
        public static Configure Configure_interface = null;
        private string MyDepartment = "";//工厂信息

        public string MyToolName = "";
        public Configure()
        {
            InitializeComponent();
            Configure_interface = this;
            MyDepartment = LoadForm.Load_interface.GetRootDepartment();

            InitControl();
        }

        private void InitControl()
        {
            btnConfigSerialPort.Click += BtnConfigSerialPort_Click;
            btnConfigSerialPort.Visible = false;

            FormComboBox.SelectedValueChanged += FormComboBox_SelectedValueChanged;
        }

        private void BtnConfigSerialPort_Click(object sender, EventArgs e)
        {
            try
            {

            }
            catch (Exception ex)
            {
                MessageBox.Show("串口设置失败：" + ex.ToString());
            }
        }

        #region 传递值
        public string GetTempbatchNumber()  //传递sap订单号
        {
            //return DEVName.Text;
            return SAPDDH.Text.ToUpper();
        }


        public string GetMySAPB()  //传递SAP编号
        {
            return SAPBH.Text.ToUpper();
        }

        public string GetMyToolName()
        {
            return MyToolName;
        }

        public string GetTempfactoryId()  //传递工厂ID
        {
            return factoryIdText.Text;
        }

        public string GetTempfactoryLineId()  //传递产线ID
        {
            return factoryLineIdText.Text;
        }

        public string GetProductModel()  //传递设备型号
        {
            return ProductModel.Text;
        }

        public string GetProductName()  //传递设备名称
        {
            return DevNameText.Text;
        }

        public string GetTempSVNumber()  //传递sv
        {
            return SVNumber.Text;
        }

        public string GetTempHVNumber()  //传递hv
        {
            return HVNumber.Text;
        }

        public string GetSerialSlogan1()  //传递辅助串口1
        {
            return SerialSlogan1.Text;
        }

        public string GetproductID()  //传递产品ID
        {
            return productID.Text;
        }

        public string GetMyRssi()  //传递RSSI
        {
            return RSSIText.Text;
        }

        public int GetMyPowerH()  //传递Power
        {
            string MyhighP = System.Text.RegularExpressions.Regex.Replace(HighPower.Text, @"[^0-9]+", "");
            return Convert.ToInt16(MyhighP);
        }

        public int GetMyPowerL()  //传递Power
        {
            string MyLowP = System.Text.RegularExpressions.Regex.Replace(LowPower.Text, @"[^0-9]+", "");
            return Convert.ToInt16(MyLowP);
        }

        public string GetMyForm()  //传递界面
        {
            return FormComboBox.Text;
        }

        public string GetJHH()  //传递计划号
        {
            //return DEVName.Text;
            return SAPDDH.Text.ToUpper();
        }

        public string GetWIFIName()  //传递wifi名称
        {
            return SSIDName.Text;
        }

        public string GetLayout()
        {
            return comboBox1.Text;
        }
        #endregion

        #region 窗口最大化控件变化

        ControlChangesWithWindows ConfigureWindows = new ControlChangesWithWindows(); //随窗口改变大小类的实例化
        private static int ConfigureColseAll = 1; //是否关闭所有窗口  1-关闭所有    0-关闭当前

        //将控件的宽，高，左边距，顶边距和字体大小暂存到tag属性中
        private void Configure_Load(object sender, EventArgs e)
        {
            try
            {
                btnLogWindow.Click += ConsoleShow_Click;

                ConfigureWindows.MethodForLoad(this);//调用方法
            }
            catch (Exception ex)
            {
                MessageBox.Show("界面Load-操作失败：" + ex.ToString());
            }
        }

        //根据窗体大小调整控件大小
        private void Configure_Resize(object sender, EventArgs e)
        {
            try
            {
                int Width = this.Width;

                int Height = this.Height;

                if (Width >= 816 && Height >= 528)
                {
                    this.AutoScroll = false;
                    ConfigureWindows.MethodForResize(this);// 
                }
                else
                    this.AutoScroll = true;
            }
            catch (Exception ex)
            {
                MessageBox.Show("窗口改变大小-操作失败：" + ex.ToString());
            }
        }
        #endregion

        #region 页面切换

        private void BackToLoad_Click(object sender, EventArgs e)
        {
            ConfigureColseAll = 0;
            this.Close();
        }

        private void SerialSlogan1_MouseClick(object sender, MouseEventArgs e)
        {
        }

        private void SerialSlogan2_MouseClick(object sender, MouseEventArgs e)
        {
        }
        #endregion

        #region 事件
        //关闭时显示登陆界面
        private void Configure_Closing(object sender, FormClosingEventArgs e)
        {
            try
            {
                if (ConfigureColseAll == 1)
                    System.Environment.Exit(0);
                else
                {
                    ConfigureColseAll = 1;
                    this.DialogResult = DialogResult.OK;
                }
            }
            catch (Exception ex)
            {
                MessageBox.Show("操作界面关闭-操作失败：" + ex.ToString());
            }
        }

        //点击确定，进入测试界面
        private void ConfigureOK_Click(object sender, EventArgs e)
        {
            try
            {
                ConfigureText.Visible = false;

                CreatePvtForm();

                //验证正确，登陆配置界面
                this.Hide();                                       //隐藏主界面    
                FormMain FCTest = new FormMain();
                if (FCTest.ShowDialog() == DialogResult.OK)         //以对话框形式显示配置界面
                {
                    this.Show();                                   //显示主界面
                }
            }
            catch (Exception ex)
            {
                MessageBox.Show("确定按钮-操作失败：" + ex.ToString());
            }
        }

        private void DEVName_SelectedIndexChanged(object sender, EventArgs e)
        {
            GetSelectedItem();
        }

        private void GetSelectedItem()
        {
            try
            {
                if (DEVName.Text.Contains("请选择"))
                {
                    return;
                }
            }
            catch (Exception ex)
            {
                MessageBox.Show("选择工单-操作失败：" + ex.ToString());
            }
        }

        #endregion


        #region 测试阶段 + 测试界面的配置选择

        private void XMLComboBox_SelectedIndexChanged(object sender, EventArgs e)
        {
            BindProcessStepOption();
        }

        private void BindProcessStepOption(string Str = "")
        {
            FormComboBox.Items.Clear();
            if (Str == "")
                Str = XMLComboBox.Text;
        }

        private void FormComboBox_SelectedValueChanged(object sender, EventArgs e)
        {
            CreatePvtForm();
        }

        private void CreatePvtForm()
        {
        }

        #endregion


        private void DEVName_TextChanged(object sender, EventArgs e)
        {
            //Console.WriteLine("DEVName_TextChanged:{0}, [SelectedValue:{1}]", DEVName.Text, UtilControlDataBind.GetSelectedItemValue(DEVName));
            GetSelectedItem();
        }



        private void ConsoleShow_Click(object sender, EventArgs e)
        {
        }
    }
}
