﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace KonkeDemo
{
    public partial class UserControlmodular : UserControl
    {
        private UCPanelTitleInfo textinfo = new UCPanelTitleInfo();
        private UCPanelTitle texttitle = new UCPanelTitle();

        public UserControlmodular()
        {
            InitializeComponent();

            textinfo.Msg = "deviceid: 010203";
            textinfo.Msg = "RSSI: -90";
            textinfo.Msg = "SoftVersion: 1.0";
            textinfo.Msg = "HardVersion: 2.0";
            textinfo.Msg = "Installcode: 290001";
            textinfo.Msg = "MAC: 123456789";
            ucNavigationMenuExt1.Items[0].ShowControl = textinfo;

            //ucNavigationMenuExt1.Items[1].TipText = "2";
            //ucNavigationMenuExt1.Items[1].ShowTip = true;
            //texttitle.Msg = DateTime.Now.ToString("yyyy-mm-dd HH:mm:ss") + ": " + "入网失败";
            //text.Text = "读取信号强度失败";
            ucNavigationMenuExt1.Items[1].ShowControl = texttitle;
        }

        public string TipText
        {
            set
            {
                ucNavigationMenuExt1.Invoke(new EventHandler(delegate
                {
                    ucNavigationMenuExt1.Items[1].ShowTip = true;
                    ucNavigationMenuExt1.Items[1].TipText = value;
                    this.Refresh();
                }));
            }
        }

        public string Infomsg
        {
            set
            {
                textinfo.Msg = value;
            }
        }

        public string Errormsg
        {
            set
            {
                texttitle.Msg = DateTime.Now.ToString("yyyy-mm-dd HH:mm:ss") + ": " + value.ToString();
                this.Refresh();

            }
        }

        public string SN
        {
            get
            {
                return textEdit1.Text.Trim();
            }
            set
            {
                textEdit1.Text = value;
            }
        }

        public int Process
        {
            set
            {
                ucProcessLine1.Value = value;
            }
        }

        public int iconclusion
        {
            set
            {
                if (value == 1)
                {
                    label2.Text = "测试成功";
                    panel3.BackColor = Color.SpringGreen;
                }
                else if (value == 0)
                {
                    label2.Text = "测试失败";
                    panel3.BackColor = Color.Red;
                }
                else if (value == 2)
                {
                    label2.Text = "准备";
                    panel3.BackColor = Color.Gold;
                }
            }
        }

        public int position
        {
            set
            {
                label3.Text = value.ToString();
            }
        }

        public int ControlWidth
        {
            get
            {
                return this.Width;
            }
        }

        public string status
        {
            set
            {
                label2.Text = value.ToString();
            }
        }

        private int errorcnt;
        public int ErrorCnt 
        {
            get { return errorcnt; }
            set { errorcnt = value; }
        }
        private List<string> TErrorlog = new List<string>();
        public virtual void ViewLog(Helper.CustomMessage customMessage, string message)
        {
            try
            {
                switch (customMessage)
                {
                    case Helper.CustomMessage.ViewLog:
                        label2.Invoke(new EventHandler(delegate
                        {
                            label2.Text = message;
                        }));
                        break;
                    case Helper.CustomMessage.Alarm:
                        //texttitle = new UCPanelTitle();
                        ErrorCnt++;
                        TErrorlog.Add(message);
                        //TipText = ErrorCnt.ToString();
                        //Errormsg = message;
                        break;
                    case Helper.CustomMessage.QuerySN:
                        break;
                    case Helper.CustomMessage.Stop:
                        break;
                    case Helper.CustomMessage.Progress:
                        int process = 0;
                        if (int.TryParse(message, out process)) 
                        {
                            ucProcessLine1.Invoke(new EventHandler(delegate
                            {
                                ucProcessLine1.Value = process;

                            }));
                        }
                        break;
                    case Helper.CustomMessage.Result:
                        if (message.Equals("0"))
                        {
                            panel3.Invoke(new EventHandler(delegate
                            {
                                panel3.BackColor = Color.Red;
                                panel3.Refresh();
                            }));
                        }
                        else if (message.Equals("1"))
                        {
                            panel3.Invoke(new EventHandler(delegate
                            {
                                panel3.BackColor = Color.SpringGreen;
                                panel3.Refresh();
                            }));
                        }
                        break;

                }
            }
            catch(Exception exc) { }
        }
        public void fnUpdate() 
        {
            if (ErrorCnt > 0)
            {
                TipText = ErrorCnt.ToString();
                for (int i = 0; i < TErrorlog.Count; i++)
                {
                    Errormsg = TErrorlog[i];
                }
            }
        }

        public void Finished()
        {
            textEdit1.Invoke(new EventHandler(delegate
            {
                textEdit1.Enabled = true;
            }));
        }

        public void Init() 
        {
            ErrorCnt = 0;
            TErrorlog = new List<string>();
            ucNavigationMenuExt1.Invoke(new EventHandler(delegate
            {
                ucNavigationMenuExt1.Items[1].ShowTip = false;
                this.Refresh();
            }));
            this.BackColor = System.Drawing.Color.Aqua;
            Process = 0;
            iconclusion = 2;
            texttitle.Clear();
            textEdit1.Invoke(new EventHandler(delegate
            {
                textEdit1.Enabled = false;
            }));
        }
        public void Run(object obj)
        {
            bTest = true;
            topSeconds = 0;
            AutoTestService autoTest = new AutoTestService();
            autoTest.SendMessage += ViewLog;
            autoTest.Run(new object());
            autoTest.SendMessage -= ViewLog;
            bTest = false;
            topSeconds = 0;
        }
        private bool bTest = false;
        private int topSeconds = 0;
        private void timer1_Tick(object sender, EventArgs e)
        {
            try
            {
                if (bTest)
                {
                    topSeconds++;
                    label1.Invoke(new EventHandler(delegate
                    {
                        label1.Text = string.Format("耗时: {0} S", topSeconds);

                    }));
                }
            }
            catch { }
        }
    }
}
